classification
Title: [C API] Document PyTypeObject.tp_print removal in What's New In Python 3.9
Type: Stage: resolved
Components: C API Versions: Python 3.9
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: vstinner
Priority: normal Keywords: patch

Created on 2020-01-16 13:47 by vstinner, last changed 2020-01-24 10:35 by vstinner. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 18125 merged ammar2, 2020-01-22 20:08
Messages (2)
msg360120 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2020-01-16 13:47
commit aacc77fbd77640a8f03638216fa09372cc21673d
Author: Jeroen Demeyer <J.Demeyer@UGent.be>
Date:   Wed May 29 20:31:52 2019 +0200

    bpo-36974: implement PEP 590 (GH-13185)
    
    
    Co-authored-by: Jeroen Demeyer <J.Demeyer@UGent.be>
    Co-authored-by: Mark Shannon <mark@hotpy.org>

removed PyTypeObject.tp_print:

diff --git a/Include/cpython/object.h b/Include/cpython/object.h
index ba52a48358..a65aaf6482 100644
--- a/Include/cpython/object.h
+++ b/Include/cpython/object.h
@@ -182,7 +182,7 @@ typedef struct _typeobject {
     /* Methods to implement standard operations */
 
     destructor tp_dealloc;
-    printfunc tp_print;
+    Py_ssize_t tp_vectorcall_offset;
     getattrfunc tp_getattr;
     setattrfunc tp_setattr;
     PyAsyncMethods *tp_as_async; /* formerly known as tp_compare (Python 2)


Would it be possible to just document it in What's New in Python 3.9? Near:
https://docs.python.org/dev/whatsnew/3.9.html#build-and-c-api-changes


For example, this incompatible change broke zbar project:
https://bugzilla.redhat.com/show_bug.cgi?id=1791745
msg360607 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2020-01-24 10:35
New changeset 2d5097663d7f80921fb07cdcd26c9d59cf71f1a2 by Victor Stinner (Ammar Askar) in branch 'master':
bpo-39361: Document the removal of PyTypeObject.tp_print (GH-18125)
https://github.com/python/cpython/commit/2d5097663d7f80921fb07cdcd26c9d59cf71f1a2
History
Date User Action Args
2020-01-24 10:35:36vstinnersetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2020-01-24 10:35:07vstinnersetmessages: + msg360607
2020-01-22 20:08:12ammar2setkeywords: + patch
stage: patch review
pull_requests: + pull_request17512
2020-01-16 13:47:29vstinnercreate